"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRexStore = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const createRexStore = useRexState => {
  const RexContext = /*#__PURE__*/(0, _react.createContext)(null);
  const {
    Provider
  } = RexContext;

  const useStore = () => {
    const store = (0, _react.useContext)(RexContext);

    if (!store) {
      throw new Error('Component must be wrapped with a suitable <RexProvider>');
    }

    return store;
  };

  const RexProvider = ({
    children,
    value
  }) => {
    const state = useRexState(value);
    return /*#__PURE__*/_react.default.createElement(Provider, {
      value: state
    }, children);
  };

  return {
    RexProvider,
    useStore
  };
};

exports.createRexStore = createRexStore;
//# sourceMappingURL=index.js.map