import React, { createContext, useContext } from 'react';
export const createRexStore = useRexState => {
  const RexContext = /*#__PURE__*/createContext(null);
  const {
    Provider
  } = RexContext;

  const useStore = () => {
    const store = useContext(RexContext);

    if (!store) {
      throw new Error('Component must be wrapped with a suitable <RexProvider>');
    }

    return store;
  };

  const RexProvider = ({
    children,
    value
  }) => {
    const state = useRexState(value);
    return /*#__PURE__*/React.createElement(Provider, {
      value: state
    }, children);
  };

  return {
    RexProvider,
    useStore
  };
};
//# sourceMappingURL=index.js.map